import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

/**
 * 
 * @author CS2334. Modified by: MANVIR KAUR
 * @version 2017-10-19
 *          <P>
 *          Lab 9
 *          <P>
 *          This class creates a GUI for simple Binary calculator
 *          application
 * 
 */

public class CalculatorFrame extends JFrame
{
    /** Use default UID */
    private static final long serialVersionUID = 1L;

    /** panel for the binary inputs */
    JPanel panel1 = new JPanel(new GridLayout(5, 0));
    /** panel for the error message */
    JPanel panel2 = new JPanel();
    /** panel for the calculate result button */
    JPanel panel3 = new JPanel();
    /** panel for the radio buttons */
    JPanel panel4 = new JPanel();

    /** Group of operation buttons */
    ButtonGroup ops = new ButtonGroup();

    /** Calculate result button */
    JButton button = new JButton("Calculate 2Result");

    /** Text that describes which operator is being used */
    JLabel opSign = new JLabel();
    /** Text that display an equals sign*/
    JLabel equalsSign = new JLabel("=  ");
    /** Text that display an error message */
    JLabel errorMessage = new JLabel();

    /** Text field for the user's first input */
    JTextField firstBox = new JTextField(5);
    /** Text field for the user's second input */
    JTextField secondBox = new JTextField(5);
    /** Text field for the computed result */
    JTextField computeResult = new JTextField();

    /** and operation radio button */
    JRadioButton and = new JRadioButton("&");
    /** or operation radio button */
    JRadioButton or = new JRadioButton("|");
    /** xor operation radio button */
    JRadioButton xor = new JRadioButton("^");

    /**
     * This method builds and operates the GUI window.
     * @param title The title of the window.
     */
    public CalculatorFrame(String title) 
    {
        // Initialize the frame
        super(title);

        // Set Alignment of the JTextField and Jlabel
        firstBox.setHorizontalAlignment(JTextField.RIGHT);
        secondBox.setHorizontalAlignment(JTextField.RIGHT);
        opSign.setHorizontalAlignment(JLabel.RIGHT);
        equalsSign.setHorizontalAlignment(JLabel.RIGHT);
        computeResult.setHorizontalAlignment(JTextField.RIGHT);

        // Change computeResult to be non-editable
        computeResult.setEditable(false);

        // DO NOT CHANGE THE NAMES OR YOU WILL BREAK OUR UNIT TESTING
        errorMessage.setName("errorMessageText");
        firstBox.setName("input1");
        secondBox.setName("input2");
        and.setName("opAnd"); 
        or.setName("opOr");
        xor.setName("opXor");
        computeResult.setName("total");
        button.setName("calculateButton");

        //sets the layout grid for the GUI of dimension 4*5
        setLayout(new GridLayout(4, 0));

        // Add all items to the panels
        panel1.add(firstBox);
        // TODO: complete 

        // TODO: add the jpanels to the frame

        //default to and operator
        and.setSelected(true);
        opSign.setText("&  ");

        /*
         * All ActionListeners: change the opSign text to the name of
         * the respective radio Button (&, |, ^) and clear the computeResult text field
         */
        and.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                opSign.setText("&  ");
            } 
        });
        
        // TODO: complete the radio button action listeners

        /*
         * When the Calculate Result Button is pressed, 
         * get the values from the text fields and calculate the 
         * appropriate result using the three different operators (&, |, ^).
         */
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    int base = 2;
                    if (and.isSelected()) {
                        int value1 = Integer.parseInt(firstBox.getText(), base);
                        // TODO: complete AND implementation
                    }
                    
                    // TODO: complete OR and XOR implementations
                    
                    errorMessage.setText("");
                }
                catch (NumberFormatException error) {
                    // TODO: display the error message

                }
            }
        });

        // Configuring of the frame
        setSize(400, 400);
        setVisible(true);
        setResizable(false);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    /**
     * Used to create the Calculator Frame
     * @param args
     * command-line arguments - not used
     */
    public static void main(String[] args) {
        new CalculatorFrame("Binary Calculator Window");
    }
}
